#if !defined(_ADATA_DMADESC_H)
#define _ADATA_DMADESC_H

#include "platform.h"
#include "device.h"
#include "ioctls.h"

extern OS_STATUS
ADMXRC_CreateDMATarget(
  DeviceContext* pDevCtx,
  void* buffer,
  unsigned long length,
  DmaTarget** tgt);

extern void
ADMXRC_ReleaseDMATarget(
  DeviceContext* pDevCtx,
  DmaTarget* tgt);

extern DmaTarget*
ADMXRC_GetDMATarget(
  DeviceContext* pDevCtx,
  unsigned long handle);

extern void
ADMXRC_CleanupDMATargets(
  DeviceContext* pDevCtx);

extern OS_STATUS
ADMXRC_MapDirectMaster(
  DeviceContext* pDevCtx,
  OS_IO_REQUEST* pReq,
  ADMXRC_IOCTLS_MAPDIRECTMASTER* pIoctl,
  unsigned long inSize,
  unsigned long outSIze);

extern OS_STATUS
ADMXRC_SetupDMA(
  DeviceContext* pDevCtx,
  OS_IO_REQUEST* pReq,
  ADMXRC_IOCTLS_SETUPDMA* pIoctl,
  unsigned long inSize,
  unsigned long outSIze);

extern OS_STATUS
ADMXRC_SetupDMARemote(
  DeviceContext* pDevCtx,
  OS_IO_REQUEST* pReq,
  ADMXRC_IOCTLS_SETUPDMAREMOTE* pIoctl,
  unsigned long inSize,
  unsigned long outSIze);

extern OS_STATUS
ADMXRC_SyncDirectMaster(
  DeviceContext* pDevCtx,
  OS_IO_REQUEST* pReq,
  ADMXRC_IOCTLS_SYNCDIRECTMASTER* pIoctl,
  unsigned long inSize);

extern OS_STATUS
ADMXRC_UnsetupDMA(
  DeviceContext* pDevCtx,
  OS_IO_REQUEST* pReq,
  ADMXRC_IOCTLS_UNSETUPDMA* pIoctl,
  unsigned long outSIze);

#endif
