/*
** ioctl_code.h - platform independent definitions for API-to-driver interface IOCTL codes.
**
** NOTE: This file should not be included by applications. Alpha Data reserves the right to
**       modify this interface in any release of this package without notice.
**
** (C) Copyright 2000-2005 Alpha Data Ltd.
*/

#if !defined(_ADATA_ADMXRC_IOCTL_CODE_H)
#define _ADATA_ADMXRC_IOCTL_CODE_H

#include "ioctl_platform.h"

typedef enum _ADMXRC_KEY_IOCTL_CODES {
  ADMXRC_KEY_IOCTL_OPENCARD = ADMXRC_KEY_STARTIOCTL,
  ADMXRC_KEY_IOCTL_DODMA,
  ADMXRC_KEY_IOCTL_LOADFPGA,
  ADMXRC_KEY_IOCTL_WRITEREG,
  ADMXRC_KEY_IOCTL_READREG,
  ADMXRC_KEY_IOCTL_WAITFORINTERRUPT,
  ADMXRC_KEY_IOCTL_WRITE,
  ADMXRC_KEY_IOCTL_READ,
  ADMXRC_KEY_IOCTL_SETUPDMA,
  ADMXRC_KEY_IOCTL_UNSETUPDMA,
  ADMXRC_KEY_IOCTL_PROGRAMBYTES,
  ADMXRC_KEY_IOCTL_REGINTERRUPTEVENT,
  ADMXRC_KEY_IOCTL_UNREGINTERRUPTEVENT,
  ADMXRC_KEY_IOCTL_GETVERSIONINFO,
  ADMXRC_KEY_IOCTL_UNCONFIGUREFPGA,
  ADMXRC_KEY_IOCTL_CHECKFPGACONFIGURED,
  ADMXRC_KEY_IOCTL_MAPDIRECTMASTER,
  ADMXRC_KEY_IOCTL_SYNCDIRECTMASTER,
  ADMXRC_KEY_IOCTL_GETCARDINFO2,
  ADMXRC_KEY_IOCTL_GETBANKINFO,
  ADMXRC_KEY_IOCTL_OPENCARD2,
  ADMXRC_KEY_IOCTL_SETCLOCK2,
  ADMXRC_KEY_IOCTL_GETSPACEINFO,
  ADMXRC_KEY_IOCTL_READCONFIG,
  ADMXRC_KEY_IOCTL_WRITECONFIG,
  ADMXRC_KEY_IOCTL_DODMAIMMEDIATE,
  ADMXRC_KEY_IOCTL_LOADFPGADMA,
  ADMXRC_KEY_IOCTL_CANCELWAITFORINTERRUPT,
  ADMXRC_KEY_IOCTL_REGDMAEVENT,
  ADMXRC_KEY_IOCTL_GETFLASHINFO,
  ADMXRC_KEY_IOCTL_GETFLASHBLOCKINFO,
  ADMXRC_KEY_IOCTL_ERASEFLASH,
  ADMXRC_KEY_IOCTL_READFLASH,
  ADMXRC_KEY_IOCTL_WRITEFLASH,
  ADMXRC_KEY_IOCTL_GETSPACECONFIG,
  ADMXRC_KEY_IOCTL_SETSPACECONFIG,
  ADMXRC_KEY_IOCTL_DODMA2D,
  ADMXRC_KEY_IOCTL_DODMAIMMEDIATE2D,
  ADMXRC_KEY_IOCTL_SETUPDMAREMOTE,
  ADMXRC_KEY_IOCTL_LOCALBUSRESET,
  ADMXRC_KEY_IOCTL_GETGEOGRAPHICALINFO
} ADMXRC_KEY_IOCTL_CODES;

#define ADMXRC_IOCTL_SETCLOCK              ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_SETCLOCK,            ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_OPENCARD              ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_OPENCARD,            ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_LOADFPGA              ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_LOADFPGA,            ADMXRC_IOCTLF_MASS_WRITE,     ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_WRITEREG              ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_WRITEREG,            ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_READREG               ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_READREG,             ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_DODMA                 ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_DODMA,               ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_WAIT)
#define ADMXRC_IOCTL_WAITFORINTERRUPT      ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_WAITFORINTERRUPT,    ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_WRITE                 ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_WRITE,               ADMXRC_IOCTLF_MASS_WRITE,     ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_READ                  ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_READ,                ADMXRC_IOCTLF_MASS_READ,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_SETUPDMA              ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_SETUPDMA,            ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_UNSETUPDMA            ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_UNSETUPDMA,          ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_PROGRAMBYTES          ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_PROGRAMBYTES,        ADMXRC_IOCTLF_MASS_READWRITE, ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_REGINTERRUPTEVENT     ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_REGINTERRUPTEVENT,   ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_UNREGINTERRUPTEVENT   ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_UNREGINTERRUPTEVENT, ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_GETVERSIONINFO        ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_GETVERSIONINFO,      ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_UNCONFIGUREFPGA       ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_UNCONFIGUREFPGA,     ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_CHECKFPGACONFIGURED   ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_CHECKFPGACONFIGURED, ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_MAPDIRECTMASTER       ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_MAPDIRECTMASTER,     ADMXRC_IOCTLF_MASS_READ,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_SYNCDIRECTMASTER      ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_SYNCDIRECTMASTER,    ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_GETCARDINFO2          ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_GETCARDINFO2,        ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_GETBANKINFO           ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_GETBANKINFO,         ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_OPENCARD2             ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_OPENCARD2,           ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_SETCLOCK2             ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_SETCLOCK2,           ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_GETSPACEINFO          ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_GETSPACEINFO,        ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_OPENCARDBYINDEX       ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_OPENCARDBYINDEX,     ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_READCONFIG            ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_READCONFIG,          ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_WRITECONFIG           ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_WRITECONFIG,         ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_DODMAIMMEDIATE        ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_DODMAIMMEDIATE,      ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_WAIT)
#define ADMXRC_IOCTL_LOADFPGADMA           ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_LOADFPGADMA,         ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_WAIT)
#define ADMXRC_IOCTL_CANCELWAITFORINTERRUPT ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_CANCELWAITFORINTERRUPT, ADMXRC_IOCTLF_MASS_NONE, ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_REGDMAEVENT           ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_REG_DMAEVENT,        ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_GETFLASHINFO          ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_GETFLASHINFO,        ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_GETFLASHBLOCKINFO     ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_GETFLASHBLOCKINFO,   ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_ERASEFLASH            ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_ERASEFLASH,          ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_READFLASH             ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_READFLASH,           ADMXRC_IOCTLF_MASS_READ,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_WRITEFLASH            ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_WRITEFLASH,          ADMXRC_IOCTLF_MASS_WRITE,     ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_GETSPACECONFIG        ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_GETSPACECONFIG,      ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_SETSPACECONFIG        ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_SETSPACECONFIG,      ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_DODMA2D               ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_DODMA2D,             ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_WAIT)
#define ADMXRC_IOCTL_DODMAIMMEDIATE2D      ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_DODMAIMMEDIATE2D,    ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_WAIT)
#define ADMXRC_IOCTL_SETUPDMAREMOTE        ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_SETUPDMAREMOTE,      ADMXRC_IOCTLF_MASS_WRITE,     ADMXRC_IOCTLF_WAIT)
#define ADMXRC_IOCTL_LOCALBUSRESET         ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_LOCALBUSRESET,       ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)
#define ADMXRC_IOCTL_GETGEOGRAPHICALINFO   ADMXRC_MAKE_IOCTL(ADMXRC_KEY_IOCTL_GETGEOGRAPHICALINFO, ADMXRC_IOCTLF_MASS_NONE,      ADMXRC_IOCTLF_NOWAIT)

/* Additional flags that can be added by driver wrapper for DoDMA* API functions */
#define ADMXRC_DMAFLAG_TIMEOUT (0x1U << 31)

/* Signatures for EraseFlash API function */
#define ADMXRC_IOCTLS_ERASEFLASH_SIGNATURE1 (0x0516fab8U)
#define ADMXRC_IOCTLS_ERASEFLASH_SIGNATURE2 (0x694371bcU)

/* Additional flags that can be added by driver wrapper for WaitForInterrupt API function */
#define ADMXRC_INTWAIT_TIMEOUT (0x1U << 31)

/* Signatures for WriteConfig API function */
#define ADMXRC_IOCTLS_WRITECONFIG_SIGNATURE1 (0x587d3f31U)
#define ADMXRC_IOCTLS_WRITECONFIG_SIGNATURE2 (0x043a749fU)

/* Signatures for WriteFlash API function */
#define ADMXRC_IOCTLS_WRITEFLASH_SIGNATURE1 (0xd4b39c05U)
#define ADMXRC_IOCTLS_WRITEFLASH_SIGNATURE2 (0x6507e128U)

#endif
